﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;
using AForge.Video.DirectShow;
using NAudio.CoreAudioApi;
using NAudio.Wave;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using WebSocket4Net;

namespace robot
{
    public partial class Form1 : Form
    {
        private static WebSocket websocket = null;
        private string strSendText = string.Empty;

        // <summary>
        /// 键盘事件
        /// </summary>
        /// <param name="bVk"> virtual-key code</param>
        /// <param name="bScan">hardware scan code</param>
        /// <param name="dwFlags"> flags specifying various function options</param>
        /// <param name="dwExtraInfo"> additional data associated with keystroke</param>
        [DllImport("user32.dll")]
        public static extern void keybd_event(byte bVk, byte bScan, int dwFlags, int dwExtraInfo);

        [DllImport("user32.dll")]
        private static extern bool SetWindowPos(IntPtr hWnd, int hWndInsertAfter, int X, int Y, int cx, int cy, uint Flags);

        [DllImport("User32.dll", EntryPoint = "ShowWindow")]
        private static extern bool ShowWindow(IntPtr hWnd, int type);

        [DllImport("user32.dll")]
        static extern IntPtr FindWindow(string lpClassName, string lpWindowName);



        public static string CONFIG_PATH = "";

        private static JObject _config = new JObject();

        public Form1()
        {
            InitializeComponent();
            //this.WindowState = FormWindowState.Minimized;
            //this.ShowInTaskbar = false;
            //SetVisibleCore(false);

            this.Opacity = 0;
            this.SendToBack();
        }

        /// <summary>
        /// 让程序不显示在alt+Tab视图窗体中5
        /// </summary>
        protected override CreateParams CreateParams
        {
            get
            {
                const int WS_EX_APPWINDOW = 0x40000;
                const int WS_EX_TOOLWINDOW = 0x80;
                CreateParams cp = base.CreateParams;
                cp.ExStyle &= (~WS_EX_APPWINDOW);    // 不显示在TaskBar
                cp.ExStyle |= WS_EX_TOOLWINDOW;      // 不显示在Alt+Tab
                return cp;
            }
        }
        protected override void SetVisibleCore(bool value)
        {
            base.SetVisibleCore(value);
        }

        protected JObject InitConfig(string path) 
        {
            using (StreamReader file = File.OpenText(path)) 
            {
                using (JsonTextReader reader = new JsonTextReader(file)) 
                {
                    return (JObject)JToken.ReadFrom(reader);
                }
            }
        }

        private void timer1_Tick(object sender, EventArgs e)
        {

        }

        private void Form1_Load(object sender, EventArgs e)
        {
            connectionServer();
            Thread thread = new Thread(CkeckUploadFailed);
            thread.IsBackground = true;
            thread.Start();
            //OpenCamera();
        }

        public void connectionServer() 
        {
            websocket = new WebSocket("ws://127.0.0.1:4488");
            websocket.Opened += WebSocket4Net_Opened;

            websocket.Error += websocket_Error;

            websocket.Closed += new EventHandler(websocket_Closed);

            websocket.MessageReceived += WebSocket4Net_MessageReceived;

            websocket.Open();
        }
        public void ClientSendMsgToServer()
        {
            int i = 1;
            while (true)
            {
                websocket.Send("love girl" + i++);
                Thread.Sleep(TimeSpan.FromSeconds(5));
            }
        }

        private void WebSocket4Net_MessageReceived(object sender, MessageReceivedEventArgs e)
        {
            //e.Message
            Console.WriteLine(e.Message);
            if (e.Message.IndexOf("KILL-CAMERA|")!=-1)
            {
                var classId = int.Parse(e.Message.Split('|')[1]);
                KillCamera(classId);
            }
            else if (e.Message == "OPEN-CAMERA")
            {
                OpenCamera();
            }
            else if (e.Message == "CLOSE_APP")
            {
                System.Environment.Exit(0);
            }
        }

        private void WebSocket4Net_Opened(object sender, EventArgs e)
        {
            websocket.Send("i am from winforms hello jiahe！");
        }

        private void websocket_Error(object sender, EventArgs e)
        {
            Console.WriteLine(":");
            Thread.Sleep(5000);
            if (websocket.State != WebSocketState.Open && websocket.State != WebSocketState.Connecting)
            {
                connectionServer();
            }

        }

        private void websocket_Closed(object sender, EventArgs e)
        {
            Thread.Sleep(5000);
            //TODO: 启动进程
            if (websocket.State != WebSocketState.Open && websocket.State != WebSocketState.Connecting)
            {
                keybd_event((byte)Keys.F7, 0, 0, 0);
                Thread.Sleep(5000);

                Process[] processes = Process.GetProcessesByName("Captura");
                foreach (Process p in processes)
                {
                    //执行kill命令
                    p.Kill();
                    //等待被杀死的进程退出
                    p.WaitForExit();
                    //跳出foreach循环，可有可无
                    break;
                }
                System.Environment.Exit(0);
                //connectionServer();
            }

        }

        private void SaveJsonFile(string path,JObject content)
        {
            using (StreamWriter sw=new StreamWriter(path,append:false) ) {
                sw.Write(content.ToString());
                sw.Flush();
                sw.Close();
            }
        }
        



        /// <summary>
        /// 命令KILL-CAMERA
        /// </summary>
        public void KillCamera(int classId) 
        {
            keybd_event((byte)Keys.F7, 0, 0, 0);
            Thread.Sleep(5000);

            Process[] processes = Process.GetProcessesByName("Captura");
            foreach (Process p in processes)
            {
                //执行kill命令
                p.Kill();
                //等待被杀死的进程退出
                p.WaitForExit();
                //跳出foreach循环，可有可无
                break;
            }
            UploadClassVideo(classId);
        }

        public void UploadClassVideo(int objId) 
        {
            int classId = int.Parse(objId.ToString());
            var videoDirPath= $"{Application.StartupPath}video";
            var uploadTempPath = $"{Application.StartupPath}temp";
            if (Directory.Exists(videoDirPath)) 
            {
                if (!Directory.Exists(uploadTempPath)) 
                {
                    Directory.CreateDirectory(uploadTempPath);
                }
                var files = Directory.GetFiles(videoDirPath);
                foreach (var item in files)
                {
                    var file = new FileInfo(item);
                    string fileName = file.Name;
                    string name = $"甲鹤日语学习记录视-{DateTime.Now.ToString("MMDDHH")}";
                    VideoRequest request = new VodHelper().CreateUploadVideo(name,fileName);
                    request.ClassId = classId;
                    request.LocalFilePath = item;

                    var newFilePath = uploadTempPath + "\\" + request.VideoId;
                    var voideFileInfo = JsonConvert.SerializeObject(request);
                    var ms = getMemoryStream(voideFileInfo, Encoding.UTF8);
                    FileStream fs = new FileStream(newFilePath, FileMode.OpenOrCreate);
                    Byte[] btBlob = new Byte[ms.Length];
                    ms.Read(btBlob, 0, btBlob.Length);
                    fs.Write(btBlob, 0, btBlob.Length);
                    ms.Close();
                    ms.Dispose();
                    fs.Close();
                    fs.Dispose();

                    Thread thread = new Thread(new ParameterizedThreadStart(BeginUploadVideo));
                    thread.Start(request);
                }
            }
        }

        public static void BeginUploadVideo(object videoInfo)
        {
            var video = videoInfo as VideoRequest;
            VodHelper.UploadVideo(video);
            var uploadTempPath = $"{Application.StartupPath}temp\\{video.VideoId}";
            

            //websocket.Send($"UPLOAD_CLASS_STATUS:{video.ClassId}:{video.VideoId}");
            HttpHelper.HttpPost("http://192.168.20.24:8300/api/Class/UpdateTimeClassVideo", "{\"msg\":{\"ClassTimeId\":\"" + video.ClassId + "\",\"VideoUrl\":\"" + video.VideoId + "\"}}");

            File.Delete(uploadTempPath);
            File.Delete(video.LocalFilePath);
            websocket.Send($"UPLOAD_VIDEO_RESULT:{video.VideoId}");
        }

        public static void CkeckUploadFailed() 
        {
            var uploadTempPath = $"{Application.StartupPath}temp";
            if (Directory.Exists(uploadTempPath))
            {
                var files = Directory.GetFiles(uploadTempPath);
                foreach (var item in files)
                {
                    string objString = getFileToString(item);
                    VideoRequest request = JsonConvert.DeserializeObject<VideoRequest>(objString);

                    if (request!=null)
                    {
                        BeginUploadVideo(request);
                    }
                }                
            }

            var videoDirPath = $"{Application.StartupPath}video";
            foreach (var item in Directory.GetFileSystemEntries(videoDirPath))
            {
                File.Delete(item);
            }
        }

        

        public MemoryStream getMemoryStream(string strmemo, Encoding enc)
        {
            if (strmemo == string.Empty)
            {
                return null;
            }
            Byte[] btMemo = enc.GetBytes(strmemo);
            MemoryStream ms = new MemoryStream(btMemo);
            return ms;
        }

        public static string getFileToString(string filePath)
        {
            FileInfo fi = new FileInfo(filePath);
            byte[] buff = new byte[fi.Length];

            FileStream fs = fi.OpenRead();
            fs.Read(buff, 0, Convert.ToInt32(fs.Length));
            fs.Close();
            return Encoding.UTF8.GetString(buff);
        }

        /// <summary>
        /// 命令OPEN-CAMERA
        /// </summary>
        public void OpenCamera()
        {
            JArray audios = AudioDevNames();
            JArray audiouts = AudioOutDevNames();
            var videos = VideoDevNames();

            string configPath = $"{Application.StartupPath}Captura/Captura.json";
            JObject config = InitConfig(configPath);
            config["FFmpeg"]["FolderPath"] = $"{Application.StartupPath}jhcaptura\\ffmpeg\\bin";
            config["OutPath"] = $"{Application.StartupPath}video";
            config["Audio"]["Microphones"] = audios;
            config["Audio"]["Speakers"] = audiouts;
            if (videos.Count > 0)
            {
                config["Video"]["Webcam"] = videos[0];

            }
            else
            {
                config["Video"]["Webcam"] = "无摄像头";

            }

            var q = Screen.AllScreens;
            if (Screen.AllScreens.Length > 1)
            {
                config["Video"]["SourceKind"] = "Screen";
                config["Video"]["Source"] = Screen.AllScreens[0].DeviceName;
            }
            else
            {
                config["Video"]["SourceKind"] = "FullScreen";
                config["Video"]["Source"] = "";
            }

            SaveJsonFile(configPath, config);
            string appdata = Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData) + "\\Captura";
            string configDir = $"{Application.StartupPath}Captura";
            CopyDirectory(configDir, appdata, true);

            Process lupinSys = new Process();
            lupinSys.StartInfo.FileName = $"{Application.StartupPath}jhcaptura\\captura.exe";
            lupinSys.Start();
            var address = IntPtr.Zero;
            while (true)
            {
                address = FindWindow(null, "Captura");
                if (address == IntPtr.Zero)
                {
                    Thread.Sleep(100);
                }
                else
                {
                    break;
                }
            }

            SetWindowPos(address, 0, -500, -800, 450, 604, 1);
            Thread.Sleep(1000);
            ShowWindow(address, 0);
            SetTrayIconVisible("Captura", false);
            //deleteAllFile($"{Application.StartupPath}video");
            keybd_event((byte)Keys.F7, 0, 0, 0);
            Thread.Sleep(1000);
        }

        

        public void deleteAllFile(string path)
        {
            foreach (var item in Directory.GetFileSystemEntries(path))
            {
                File.Delete(item);
            }
        }

        private static IntPtr TrayToolbarWindow32()
        {
            IntPtr h = IntPtr.Zero;
            IntPtr hTemp = IntPtr.Zero;

            h = Win32API.FindWindow("Shell_TrayWnd",null); //托盘容器 
            h = Win32API.FindWindowEx(h, IntPtr.Zero, "TrayNotifyWnd", null);//找到托盘 
            h = Win32API.FindWindowEx(h, IntPtr.Zero, "SysPager", null);

            hTemp = Win32API.FindWindowEx(h, IntPtr.Zero, "ToolbarWindow32", null);

            return hTemp;
        }

        public static void SetTrayIconVisible(string caption, bool isShow)
        {
            IntPtr vHandle = TrayToolbarWindow32();
            int vCount = Win32API.SendMessage(vHandle, Win32API.TB_BUTTONCOUNT, 0, 0);
            IntPtr vProcessId = IntPtr.Zero;
            Win32API.GetWindowThreadProcessId(vHandle, ref vProcessId);
            IntPtr vProcess = Win32API.OpenProcess(Win32API.PROCESS_VM_OPERATION | Win32API.PROCESS_VM_READ |
            Win32API.PROCESS_VM_WRITE, IntPtr.Zero, vProcessId);
            IntPtr vPointer = Win32API.VirtualAllocEx(vProcess, (int)IntPtr.Zero, 0x1000,
            Win32API.MEM_RESERVE | Win32API.MEM_COMMIT, Win32API.PAGE_READWRITE);
            char[] vBuffer = new char[256];
            IntPtr pp = Marshal.UnsafeAddrOfPinnedArrayElement(vBuffer, 0);
            uint vNumberOfBytesRead = 0;
            try
            {
                for (int i = 0; i < vCount; i++)
                {
                    Win32API.SendMessage(vHandle, Win32API.TB_GETBUTTONTEXT, i, vPointer.ToInt32());

                    Win32API.ReadProcessMemoryEx(vProcess, vPointer,
                    Marshal.UnsafeAddrOfPinnedArrayElement(vBuffer, 0),
                    vBuffer.Length * sizeof(char), ref vNumberOfBytesRead);

                    int l = 0;
                    for (int j = 0; j < vBuffer.Length; j++)
                    {
                        if (vBuffer[j] == (char)0)
                        {
                            l = j;
                            break;
                        }
                    }
                    string s = new string(vBuffer, 0, l);

                    if (s.IndexOf(caption) >= 0)
                    {
                        if (isShow)
                            Win32API.SendMessage(vHandle, Win32API.TB_HIDEBUTTON, i, 0);
                        else
                            Win32API.SendMessage(vHandle, Win32API.TB_HIDEBUTTON, i, 1);
                    }
                    Console.WriteLine(s);
                }
            }
            finally
            {
                Win32API.VirtualFreeEx(vProcess, vPointer, 0, Win32API.MEM_RELEASE);
                Win32API.CloseHandle(vProcess);
            }
        }

        public JArray AudioDevNames() 
        {
            List<string> devs = new List<string>();

            MMDeviceEnumerator enumberator = new MMDeviceEnumerator();
            MMDeviceCollection deviceCollection = enumberator.EnumerateAudioEndPoints(DataFlow.Capture, DeviceState.All);
            for (int waveInDevice = 0; waveInDevice < WaveIn.DeviceCount; waveInDevice++)
            {
                WaveInCapabilities deviceInfo = WaveIn.GetCapabilities(waveInDevice);
                foreach (MMDevice device in deviceCollection)
                {
                    if (device.FriendlyName.StartsWith(deviceInfo.ProductName))
                    {
                        devs.Add(device.FriendlyName);
                        break;
                    }
                }
            }

            return JArray.FromObject(devs);
        }

        public JArray AudioOutDevNames()
        {
            List<string> devs = new List<string>();

            MMDeviceEnumerator enumberator = new MMDeviceEnumerator();
            MMDeviceCollection deviceCollection = enumberator.EnumerateAudioEndPoints(DataFlow.Render, DeviceState.All);
            for (int waveOutDevice = 0; waveOutDevice < WaveOut.DeviceCount; waveOutDevice++)
            {
                WaveOutCapabilities deviceInfo = WaveOut.GetCapabilities(waveOutDevice);
                foreach (MMDevice device in deviceCollection)
                {
                    if (device.State== DeviceState.Active && device.FriendlyName.StartsWith(deviceInfo.ProductName))
                    {
                        devs.Add(device.FriendlyName);
                        break;
                    }
                }
            }

            return JArray.FromObject(devs);
        }

        public List<string> VideoDevNames()
        {
            List<string> devs = new List<string>();
            var videoDevices = new FilterInfoCollection(FilterCategory.VideoInputDevice);
            foreach (FilterInfo device in videoDevices)
            {
                if (!device.Name.Equals("OBS Virtual Camera"))
                {
                    devs.Add(device.Name);
                }
            }


            return devs;
        }



        private static bool CopyDirectory(string SourcePath, string DestinationPath, bool overwriteexisting)
        {
            bool ret = false;
            try
            {
                SourcePath = SourcePath.EndsWith(@"\") ? SourcePath : SourcePath + @"\";
                DestinationPath = DestinationPath.EndsWith(@"\") ? DestinationPath : DestinationPath + @"\";

                if (Directory.Exists(SourcePath))
                {
                    if (Directory.Exists(DestinationPath) == false)
                        Directory.CreateDirectory(DestinationPath);

                    foreach (string fls in Directory.GetFiles(SourcePath))
                    {
                        FileInfo flinfo = new FileInfo(fls);
                        flinfo.CopyTo(DestinationPath + flinfo.Name, overwriteexisting);
                    }
                    foreach (string drs in Directory.GetDirectories(SourcePath))
                    {
                        DirectoryInfo drinfo = new DirectoryInfo(drs);
                        if (CopyDirectory(drs, DestinationPath + drinfo.Name, overwriteexisting) == false)
                            ret = false;
                    }
                }
                ret = true;
            }
            catch (Exception ex)
            {
                ret = false;
            }
            return ret;
        }

        
    }
}
